local t=require"luci.model.uci".cursor()
local a=require"luci.sys"
local s=require"luci.util"
local i=require"luci.ip"
local o="profile_"..(t:get("freifunk","community","name")or"Freifunk")
local h=i.IPv4(t:get_first(o,"community","mesh_network")or"10.0.0.0/8")
local r=t:get_first(o,"community","ipv6")or 0
local l=t:get_first(o,"community","ipv6_config")or"static"
local c=t:get("meshwizard","ipv6","enabled")or 0
local u=t:get_first(o,"community","vap")or 0
m=Map("meshwizard",translate("Wizard"),translate("This wizard will assist you in setting up your router for Freifunk "..
"or another similar wireless community network."))
n=m:section(NamedSection,"netconfig",nil,translate("Interfaces"))
n.anonymous=true
function cbi_configure(e)
local e=n:taboption(e,Flag,e.."_config",translate("Configure this interface"),
translate("Note: this will set up this interface for mesh operation, i.e. add it to zone 'freifunk' and enable olsr."))
end
function cbi_ip4addr(e)
local t=n:taboption(e,Value,e.."_ip4addr",translate("Mesh IP address"),
translate("This is a unique address in the mesh (e.g. 10.1.1.1) and has to be registered at your local community."))
t:depends(e.."_config",1)
t.datatype="ip4addr"
function t.validate(t,e)
local t=i.IPv4(e)
if h:contains(t)then
return e
else
return nil,translate("The given IP address is not inside the mesh network range ")..
"("..h:string()..")."
end
end
end
function cbi_ip6addr(e)
local t=n:taboption(e,Value,e.."_ip6addr",translate("Mesh IPv6 address"),
translate("This is a unique IPv6 address in CIDR notation (e.g. 2001:1:2:3::1/64) and has to be registered at your local community."))
t:depends(e.."_config",1)
t.datatype="ip6addr"
end
function cbi_dhcp(e)
local t=n:taboption(e,Flag,e.."_dhcp",translate("Enable DHCP"),
translate("DHCP will automatically assign ip addresses to clients"))
t:depends(e.."_config",1)
t.rmempty=true
end
function cbi_ra(e)
local t=n:taboption(e,Flag,e.."_ipv6ra",translate("Enable RA"),
translate("Send router advertisements on this device."))
t:depends(e.."_config",1)
t.rmempty=true
end
function cbi_dhcprange(e)
local t=n:taboption(e,Value,e.."_dhcprange",translate("DHCP IP range"),
translate("The IP range from which clients are assigned ip addresses (e.g. 10.1.2.1/28). "..
"If this is a range inside your mesh network range, then it will be announced as HNA. Any other range will use NAT. "..
"If left empty then the defaults from the community profile will be used."))
t:depends(e.."_dhcp","1")
t.rmempty=true
t.datatype="ip4addr"
end
local e={}
t:foreach("wireless","wifi-device",function(t)
local t=t[".name"]
table.insert(e,t)
end)
local d={}
t:foreach("network","interface",function(t)
local t=t[".name"]
if not s.contains(e,t)and t~="loopback"and not t:find("wireless")then
table.insert(e,t)
table.insert(d,t)
end
end)
for a,e in s.spairs(e,function(a,t)return(e[a]<e[t])end)do
n:tab(e,e)
end
t:foreach("wireless","wifi-device",function(h)
local e=h[".name"]
local i=h.type
local t=h.country or t:get(o,"wifi_device","country")or
t:get("freifunk","wifi_device","country")
cbi_configure(e)
if i=="atheros"then
local e=s.trim(a.exec("grep -i '"..t.."' /lib/wifi/cc_translate.txt |cut -d ' ' -f 2"))or 0
a.exec('"echo " .. cc .. " > /proc/sys/dev/" .. device .. "/countrycode"')
elseif i=="mac80211"then
a.exec("iw reg set "..t)
elseif i=="broadcom"then
a.exec("wlc country "..t)
end
local o=n:taboption(e,ListValue,e.."_channel",translate("Channel"),
translate("Your device and neighbouring nodes have to use the same channel."))
o:depends(e.."_config",1)
o:value('default')
local t=a.wifi.getiwinfo(e)
if t and t.freqlist then
for t,e in ipairs(t.freqlist)do
if not e.restricted then
o:value(e.channel)
end
end
end
cbi_ip4addr(e)
cbi_dhcp(e)
cbi_dhcprange(e)
if r=="1"then
if l=="static"then
cbi_ip6addr(e)
end
cbi_ra(e)
end
local t=0
if a.call("/usr/bin/meshwizard/helpers/supports_vap.sh "..e.." "..i)==0 then
t=1
end
if t==1 then
local t=n:taboption(e,Flag,e.."_vap",translate("Virtual Access Point (VAP)"),
translate("This will setup a new virtual wireless interface in Access Point mode."))
t:depends(e.."_dhcp","1")
t.rmempty=true
if u=="1"then
t.default="1"
end
end
end)
for t,e in pairs(d)do
cbi_configure(e)
cbi_ip4addr(e)
cbi_dhcp(e)
cbi_dhcprange(e)
if r=="1"then
if l=="static"then
cbi_ip6addr(e)
end
cbi_ra(e)
end
end
g=m:section(TypedSection,"general",translate("General Settings"))
g.anonymous=true
local e=g:option(Flag,"cleanup",translate("Cleanup config"),
translate("If this is selected then config is cleaned before setting new config options."))
e.default="1"
local e=g:option(Flag,"local_restrict",translate("Protect LAN"),
translate("Check this to protect your LAN from other nodes or clients").." ("..translate("recommended")..").")
local e=g:option(Flag,"sharenet",translate("Share your internet connection"),
translate("Select this to allow others to use your connection to access the internet."))
e.rmempty=true
if r=="1"then
v6=m:section(NamedSection,"ipv6",nil,translate("IPv6 Settings"))
local e=v6:option(Flag,"enabled",translate("Enabled"),
translate("Activate or deactivate IPv6 config globally."))
e.default=c
e.rmempty=false
end
return m
